Index: kernel/arch/arm32/include/arch/mm/page.h
===================================================================
--- kernel/arch/arm32/include/arch/mm/page.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/arm32/include/arch/mm/page.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -46,13 +46,4 @@
 #define PAGE_SIZE	FRAME_SIZE
 
-#if (defined MACHINE_beagleboardxm) || (defined MACHINE_beaglebone)
-#ifndef __ASM__
-#	define KA2PA(x)	((uintptr_t) (x))
-#	define PA2KA(x)	((uintptr_t) (x))
-#else
-#	define KA2PA(x)	(x)
-#	define PA2KA(x)	(x)
-#endif
-#else
 #ifndef __ASM__
 #	define KA2PA(x)	(((uintptr_t) (x)) - 0x80000000)
@@ -62,58 +53,57 @@
 #	define PA2KA(x)	((x) + 0x80000000)
 #endif
-#endif
 
 /* Number of entries in each level. */
-#define PTL0_ENTRIES_ARCH       (1 << 12)       /* 4096 */
-#define PTL1_ENTRIES_ARCH       0
-#define PTL2_ENTRIES_ARCH       0
+#define PTL0_ENTRIES_ARCH 	(1 << 12)	/* 4096 */
+#define PTL1_ENTRIES_ARCH 	0
+#define PTL2_ENTRIES_ARCH 	0
 /* coarse page tables used (256 * 4 = 1KB per page) */
-#define PTL3_ENTRIES_ARCH       (1 << 8)        /* 256 */
+#define PTL3_ENTRIES_ARCH 	(1 << 8)	/* 256 */
 
 /* Page table sizes for each level. */
-#define PTL0_SIZE_ARCH          FOUR_FRAMES
-#define PTL1_SIZE_ARCH          0
-#define PTL2_SIZE_ARCH          0
-#define PTL3_SIZE_ARCH          ONE_FRAME
+#define PTL0_SIZE_ARCH 		FOUR_FRAMES
+#define PTL1_SIZE_ARCH 		0
+#define PTL2_SIZE_ARCH 		0
+#define PTL3_SIZE_ARCH 		ONE_FRAME
 
 /* Macros calculating indices into page tables for each level. */
-#define PTL0_INDEX_ARCH(vaddr)  (((vaddr) >> 20) & 0xfff)
-#define PTL1_INDEX_ARCH(vaddr)  0
-#define PTL2_INDEX_ARCH(vaddr)  0
-#define PTL3_INDEX_ARCH(vaddr)  (((vaddr) >> 12) & 0x0ff)
+#define PTL0_INDEX_ARCH(vaddr) 	(((vaddr) >> 20) & 0xfff)
+#define PTL1_INDEX_ARCH(vaddr) 	0
+#define PTL2_INDEX_ARCH(vaddr) 	0
+#define PTL3_INDEX_ARCH(vaddr) 	(((vaddr) >> 12) & 0x0ff)
 
 /* Get PTE address accessors for each level. */
 #define GET_PTL1_ADDRESS_ARCH(ptl0, i) \
-        ((pte_t *) ((((pte_t *)(ptl0))[(i)].l0).coarse_table_addr << 10))
+	((pte_t *) ((((pte_t *)(ptl0))[(i)].l0).coarse_table_addr << 10))
 #define GET_PTL2_ADDRESS_ARCH(ptl1, i) \
-        (ptl1)
+	(ptl1)
 #define GET_PTL3_ADDRESS_ARCH(ptl2, i) \
-        (ptl2)
+	(ptl2)
 #define GET_FRAME_ADDRESS_ARCH(ptl3, i) \
-        ((uintptr_t) ((((pte_t *)(ptl3))[(i)].l1).frame_base_addr << 12))
+	((uintptr_t) ((((pte_t *)(ptl3))[(i)].l1).frame_base_addr << 12))
 
 /* Set PTE address accessors for each level. */
 #define SET_PTL0_ADDRESS_ARCH(ptl0) \
-        (set_ptl0_addr((pte_t *) (ptl0)))
+	(set_ptl0_addr((pte_t *) (ptl0)))
 #define SET_PTL1_ADDRESS_ARCH(ptl0, i, a) \
-        (((pte_t *) (ptl0))[(i)].l0.coarse_table_addr = (a) >> 10)
+	(((pte_t *) (ptl0))[(i)].l0.coarse_table_addr = (a) >> 10)
 #define SET_PTL2_ADDRESS_ARCH(ptl1, i, a)
 #define SET_PTL3_ADDRESS_ARCH(ptl2, i, a)
 #define SET_FRAME_ADDRESS_ARCH(ptl3, i, a) \
-        (((pte_t *) (ptl3))[(i)].l1.frame_base_addr = (a) >> 12)
+	(((pte_t *) (ptl3))[(i)].l1.frame_base_addr = (a) >> 12)
 
 /* Get PTE flags accessors for each level. */
 #define GET_PTL1_FLAGS_ARCH(ptl0, i) \
-        get_pt_level0_flags((pte_t *) (ptl0), (size_t) (i))
+	get_pt_level0_flags((pte_t *) (ptl0), (size_t) (i))
 #define GET_PTL2_FLAGS_ARCH(ptl1, i) \
-        PAGE_PRESENT
+	PAGE_PRESENT
 #define GET_PTL3_FLAGS_ARCH(ptl2, i) \
-        PAGE_PRESENT
+	PAGE_PRESENT
 #define GET_FRAME_FLAGS_ARCH(ptl3, i) \
-        get_pt_level1_flags((pte_t *) (ptl3), (size_t) (i))
+	get_pt_level1_flags((pte_t *) (ptl3), (size_t) (i))
 
 /* Set PTE flags accessors for each level. */
 #define SET_PTL1_FLAGS_ARCH(ptl0, i, x) \
-        set_pt_level0_flags((pte_t *) (ptl0), (size_t) (i), (x))
+	set_pt_level0_flags((pte_t *) (ptl0), (size_t) (i), (x))
 #define SET_PTL2_FLAGS_ARCH(ptl1, i, x)
 #define SET_PTL3_FLAGS_ARCH(ptl2, i, x)
@@ -129,14 +119,224 @@
 	set_pt_level1_present((pte_t *) (ptl3), (size_t) (i))
 
-#if defined(PROCESSOR_ARCH_armv6) | defined(PROCESSOR_ARCH_armv7_a)
-#include "page_armv6.h"
-#elif defined(PROCESSOR_ARCH_armv4) | defined(PROCESSOR_ARCH_armv5)
-#include "page_armv4.h"
-#else
-#error "Unsupported architecture"
+/* Macros for querying the last-level PTE entries. */
+#define PTE_VALID_ARCH(pte) \
+	(*((uint32_t *) (pte)) != 0)
+#define PTE_PRESENT_ARCH(pte) \
+	(((pte_t *) (pte))->l0.descriptor_type != 0)
+#define PTE_GET_FRAME_ARCH(pte) \
+	(((pte_t *) (pte))->l1.frame_base_addr << FRAME_WIDTH)
+#define PTE_WRITABLE_ARCH(pte) \
+	(((pte_t *) (pte))->l1.access_permission_0 == PTE_AP_USER_RW_KERNEL_RW)
+#define PTE_EXECUTABLE_ARCH(pte) \
+	1
+
+#ifndef __ASM__
+
+/** Level 0 page table entry. */
+typedef struct {
+	/* 0b01 for coarse tables, see below for details */
+	unsigned descriptor_type : 2;
+	unsigned impl_specific : 3;
+	unsigned domain : 4;
+	unsigned should_be_zero : 1;
+
+	/* Pointer to the coarse 2nd level page table (holding entries for small
+	 * (4KB) or large (64KB) pages. ARM also supports fine 2nd level page
+	 * tables that may hold even tiny pages (1KB) but they are bigger (4KB
+	 * per table in comparison with 1KB per the coarse table)
+	 */
+	unsigned coarse_table_addr : 22;
+} ATTRIBUTE_PACKED pte_level0_t;
+
+/** Level 1 page table entry (small (4KB) pages used). */
+typedef struct {
+
+	/* 0b10 for small pages */
+	unsigned descriptor_type : 2;
+	unsigned bufferable : 1;
+	unsigned cacheable : 1;
+
+	/* access permissions for each of 4 subparts of a page
+	 * (for each 1KB when small pages used */
+	unsigned access_permission_0 : 2;
+	unsigned access_permission_1 : 2;
+	unsigned access_permission_2 : 2;
+	unsigned access_permission_3 : 2;
+	unsigned frame_base_addr : 20;
+} ATTRIBUTE_PACKED pte_level1_t;
+
+typedef union {
+	pte_level0_t l0;
+	pte_level1_t l1;
+} pte_t;
+
+/* Level 1 page tables access permissions */
+
+/** User mode: no access, privileged mode: no access. */
+#define PTE_AP_USER_NO_KERNEL_NO	0
+
+/** User mode: no access, privileged mode: read/write. */
+#define PTE_AP_USER_NO_KERNEL_RW	1
+
+/** User mode: read only, privileged mode: read/write. */
+#define PTE_AP_USER_RO_KERNEL_RW	2
+
+/** User mode: read/write, privileged mode: read/write. */
+#define PTE_AP_USER_RW_KERNEL_RW	3
+
+
+/* pte_level0_t and pte_level1_t descriptor_type flags */
+
+/** pte_level0_t and pte_level1_t "not present" flag (used in descriptor_type). */
+#define PTE_DESCRIPTOR_NOT_PRESENT	0
+
+/** pte_level0_t coarse page table flag (used in descriptor_type). */
+#define PTE_DESCRIPTOR_COARSE_TABLE	1
+
+/** pte_level1_t small page table flag (used in descriptor type). */
+#define PTE_DESCRIPTOR_SMALL_PAGE	2
+
+
+/** Sets the address of level 0 page table.
+ *
+ * @param pt Pointer to the page table to set.
+ *
+ */
+NO_TRACE static inline void set_ptl0_addr(pte_t *pt)
+{
+	asm volatile (
+		"mcr p15, 0, %[pt], c2, c0, 0\n"
+		:: [pt] "r" (pt)
+	);
+}
+
+
+/** Returns level 0 page table entry flags.
+ *
+ * @param pt Level 0 page table.
+ * @param i  Index of the entry to return.
+ *
+ */
+NO_TRACE static inline int get_pt_level0_flags(pte_t *pt, size_t i)
+{
+	pte_level0_t *p = &pt[i].l0;
+	int np = (p->descriptor_type == PTE_DESCRIPTOR_NOT_PRESENT);
+	
+	return (np << PAGE_PRESENT_SHIFT) | (1 << PAGE_USER_SHIFT) |
+	    (1 << PAGE_READ_SHIFT) | (1 << PAGE_WRITE_SHIFT) |
+	    (1 << PAGE_EXEC_SHIFT) | (1 << PAGE_CACHEABLE_SHIFT);
+}
+
+/** Returns level 1 page table entry flags.
+ *
+ * @param pt Level 1 page table.
+ * @param i  Index of the entry to return.
+ *
+ */
+NO_TRACE static inline int get_pt_level1_flags(pte_t *pt, size_t i)
+{
+	pte_level1_t *p = &pt[i].l1;
+	
+	int dt = p->descriptor_type;
+	int ap = p->access_permission_0;
+	
+	return ((dt == PTE_DESCRIPTOR_NOT_PRESENT) << PAGE_PRESENT_SHIFT) |
+	    ((ap == PTE_AP_USER_RO_KERNEL_RW) << PAGE_READ_SHIFT) |
+	    ((ap == PTE_AP_USER_RW_KERNEL_RW) << PAGE_READ_SHIFT) |
+	    ((ap == PTE_AP_USER_RW_KERNEL_RW) << PAGE_WRITE_SHIFT) |
+	    ((ap != PTE_AP_USER_NO_KERNEL_RW) << PAGE_USER_SHIFT) |
+	    ((ap == PTE_AP_USER_NO_KERNEL_RW) << PAGE_READ_SHIFT) |
+	    ((ap == PTE_AP_USER_NO_KERNEL_RW) << PAGE_WRITE_SHIFT) |
+	    (1 << PAGE_EXEC_SHIFT) |
+	    (p->bufferable << PAGE_CACHEABLE);
+}
+
+/** Sets flags of level 0 page table entry.
+ *
+ * @param pt    level 0 page table
+ * @param i     index of the entry to be changed
+ * @param flags new flags
+ *
+ */
+NO_TRACE static inline void set_pt_level0_flags(pte_t *pt, size_t i, int flags)
+{
+	pte_level0_t *p = &pt[i].l0;
+	
+	if (flags & PAGE_NOT_PRESENT) {
+		p->descriptor_type = PTE_DESCRIPTOR_NOT_PRESENT;
+		/*
+		 * Ensures that the entry will be recognized as valid when
+		 * PTE_VALID_ARCH applied.
+		 */
+		p->should_be_zero = 1;
+	} else {
+		p->descriptor_type = PTE_DESCRIPTOR_COARSE_TABLE;
+		p->should_be_zero = 0;
+	}
+}
+
+NO_TRACE static inline void set_pt_level0_present(pte_t *pt, size_t i)
+{
+	pte_level0_t *p = &pt[i].l0;
+
+	p->should_be_zero = 0;
+	write_barrier();
+	p->descriptor_type = PTE_DESCRIPTOR_COARSE_TABLE;
+}
+
+/** Sets flags of level 1 page table entry.
+ *
+ * We use same access rights for the whole page. When page
+ * is not preset we store 1 in acess_rigts_3 so that at least
+ * one bit is 1 (to mark correct page entry, see #PAGE_VALID_ARCH).
+ *
+ * @param pt    Level 1 page table.
+ * @param i     Index of the entry to be changed.
+ * @param flags New flags.
+ *
+ */
+NO_TRACE static inline void set_pt_level1_flags(pte_t *pt, size_t i, int flags)
+{
+	pte_level1_t *p = &pt[i].l1;
+	
+	if (flags & PAGE_NOT_PRESENT)
+		p->descriptor_type = PTE_DESCRIPTOR_NOT_PRESENT;
+	else
+		p->descriptor_type = PTE_DESCRIPTOR_SMALL_PAGE;
+	
+	p->cacheable = p->bufferable = (flags & PAGE_CACHEABLE) != 0;
+	
+	/* default access permission */
+	p->access_permission_0 = p->access_permission_1 = 
+	    p->access_permission_2 = p->access_permission_3 =
+	    PTE_AP_USER_NO_KERNEL_RW;
+	
+	if (flags & PAGE_USER)  {
+		if (flags & PAGE_READ) {
+			p->access_permission_0 = p->access_permission_1 = 
+			    p->access_permission_2 = p->access_permission_3 = 
+			    PTE_AP_USER_RO_KERNEL_RW;
+		}
+		if (flags & PAGE_WRITE) {
+			p->access_permission_0 = p->access_permission_1 = 
+			    p->access_permission_2 = p->access_permission_3 = 
+			    PTE_AP_USER_RW_KERNEL_RW; 
+		}
+	}
+}
+
+NO_TRACE static inline void set_pt_level1_present(pte_t *pt, size_t i)
+{
+	pte_level1_t *p = &pt[i].l1;
+
+	p->descriptor_type = PTE_DESCRIPTOR_SMALL_PAGE;
+}
+	
+extern void page_arch_init(void);
+
+#endif /* __ASM__ */
+
 #endif
 
-#endif
-
 /** @}
  */
Index: kernel/arch/arm32/include/arch/mm/page_fault.h
===================================================================
--- kernel/arch/arm32/include/arch/mm/page_fault.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/arm32/include/arch/mm/page_fault.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -40,34 +40,18 @@
 
 
-/** Decribes CP15 "fault status register" (FSR).
- *
- * "VMSAv6 added a fifth fault status bit (bit[10]) to both the IFSR and DFSR.
- * It is IMPLEMENTATION DEFINED how this bit is encoded in earlier versions of
- * the architecture. A write flag (bit[11] of the DFSR) has also been
- * introduced."
- * ARM Architecture Reference Manual version i ch. B4.6 (PDF p. 719)
- *
- * See ARM Architecture Reference Manual ch. B4.9.6 (pdf p.743). for FSR info
- */
+/** Decribes CP15 "fault status register" (FSR). */
+typedef struct {
+	unsigned status : 3;
+	unsigned domain : 4;
+	unsigned zero : 1;
+	unsigned should_be_zero : 24;
+} ATTRIBUTE_PACKED fault_status_t;
+
+
+/** Help union used for casting integer value into #fault_status_t. */
 typedef union {
-	struct {
-		unsigned status : 4;
-		unsigned domain : 4;
-		unsigned zero : 1;
-		unsigned lpae : 1; /**< Needs LPAE support implemented */
-		unsigned fs : 1; /**< armv6+ mandated, earlier IPLM. DEFINED */
-		unsigned wr : 1; /**< armv6+ only */
-		unsigned ext : 1 ; /**< external abort */
-		unsigned cm : 1; /**< Cache maintenance, needs LPAE support */
-		unsigned should_be_zero : 18;
-	} data;
-	struct {
-		unsigned status : 4;
-		unsigned sbz0 : 6;
-		unsigned fs : 1;
-		unsigned should_be_zero : 21;
-	} inst;
-	uint32_t raw;
-} fault_status_t;
+	fault_status_t fs;
+	uint32_t dummy;
+} fault_status_union_t;
 
 
Index: kernel/arch/arm32/include/arch/regutils.h
===================================================================
--- kernel/arch/arm32/include/arch/regutils.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/arm32/include/arch/regutils.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -41,17 +41,15 @@
 #define STATUS_REG_MODE_MASK         0x1f
 
+#define CP15_R1_HIGH_VECTORS_BIT     (1 << 13)
+
 /* ARM Processor Operation Modes */
-enum {
-	USER_MODE = 0x10,
-	FIQ_MODE = 0x11,
-	IRQ_MODE = 0x12,
-	SUPERVISOR_MODE = 0x13,
-	MONITOR_MODE = 0x16,
-	ABORT_MODE = 0x17,
-	HYPERVISOR_MODE = 0x1a,
-	UNDEFINED_MODE = 0x1b,
-	SYSTEM_MODE = 0x1f,
-	MODE_MASK = 0x1f,
-};
+#define USER_MODE        0x10
+#define FIQ_MODE         0x11
+#define IRQ_MODE         0x12
+#define SUPERVISOR_MODE  0x13
+#define ABORT_MODE       0x17
+#define UNDEFINED_MODE   0x1b
+#define SYSTEM_MODE      0x1f
+
 /* [CS]PRS manipulation macros */
 #define GEN_STATUS_READ(nm, reg) \
Index: kernel/arch/arm32/src/arm32.c
===================================================================
--- kernel/arch/arm32/src/arm32.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/arm32/src/arm32.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -49,5 +49,4 @@
 #include <str.h>
 #include <arch/ras.h>
-#include <sysinfo/sysinfo.h>
 
 /** Performs arm32-specific initialization before main_bsp() is called. */
@@ -117,8 +116,4 @@
 {
 	machine_input_init();
-	const char *platform = machine_get_platform_name();
-
-	sysinfo_set_item_data("platform", NULL, (void *) platform,
-	    str_size(platform));
 }
 
@@ -138,5 +133,5 @@
 	uint8_t *stck;
 	
-	stck = &THREAD->kstack[STACK_SIZE];
+	stck = &THREAD->kstack[STACK_SIZE - SP_DELTA];
 	supervisor_sp = (uintptr_t) stck;
 }
Index: kernel/arch/arm32/src/cpu/cpu.c
===================================================================
--- kernel/arch/arm32/src/cpu/cpu.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/arm32/src/cpu/cpu.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -34,155 +34,71 @@
  */
 
-#include <arch/cache.h>
 #include <arch/cpu.h>
-#include <arch/cp15.h>
 #include <cpu.h>
 #include <arch.h>
 #include <print.h>
 
-static inline unsigned log2(unsigned val)
-{
-	unsigned log = 0;
-	--val;
-	while (val) {
-		++log;
-		val >>= 1;
-	}
-	return log;
-}
+/** Number of indexes left out in the #imp_data array */
+#define IMP_DATA_START_OFFSET 0x40
 
-static unsigned dcache_ways(unsigned level);
-static unsigned dcache_sets(unsigned level);
-static unsigned dcache_linesize_log(unsigned level);
+/** Implementators (vendor) names */
+static const char *imp_data[] = {
+	"?",					/* IMP_DATA_START_OFFSET */
+	"ARM Ltd",				/* 0x41 */
+	"",					/* 0x42 */
+	"",                             	/* 0x43 */
+	"Digital Equipment Corporation",	/* 0x44 */
+	"", "", "", "", "", "", "", "", "", "",	/* 0x45 - 0x4e */
+	"", "", "", "", "", "", "", "", "", "", /* 0x4f - 0x58 */
+	"", "", "", "", "", "", "", "", "", "", /* 0x59 - 0x62 */
+	"", "", "", "", "", "",			/* 0x63 - 0x68 */
+	"Intel Corporation"			/* 0x69 */
+};
 
-
-/** Implementers (vendor) names */
-static const char * implementer(unsigned id)
-{
-	switch (id)
-	{
-	case 0x41: return "ARM Limited";
-	case 0x44: return "Digital Equipment Corporation";
-	case 0x4d: return "Motorola, Freescale Semiconductor Inc.";
-	case 0x51: return "Qualcomm Inc.";
-	case 0x56: return "Marvell Semiconductor Inc.";
-	case 0x69: return "Intel Corporation";
-	}
-	return "Unknown implementer";
-}
+/** Length of the #imp_data array */
+static unsigned int imp_data_length = sizeof(imp_data) / sizeof(char *);
 
 /** Architecture names */
-static const char * architecture_string(cpu_arch_t *arch)
-{
-	static const char *arch_data[] = {
-		"ARM",       /* 0x0 */
-		"ARMv4",       /* 0x1 */
-		"ARMv4T",      /* 0x2 */
-		"ARMv5",       /* 0x3 */
-		"ARMv5T",      /* 0x4 */
-		"ARMv5TE",     /* 0x5 */
-		"ARMv5TEJ",    /* 0x6 */
-		"ARMv6"        /* 0x7 */
-	};
-	if (arch->arch_num < (sizeof(arch_data) / sizeof(arch_data[0])))
-		return arch_data[arch->arch_num];
-	else
-		return arch_data[0];
-}
+static const char *arch_data[] = {
+	"?",       /* 0x0 */
+	"4",       /* 0x1 */
+	"4T",      /* 0x2 */
+	"5",       /* 0x3 */
+	"5T",      /* 0x4 */
+	"5TE",     /* 0x5 */
+	"5TEJ",    /* 0x6 */
+	"6"        /* 0x7 */
+};
+
+/** Length of the #arch_data array */
+static unsigned int arch_data_length = sizeof(arch_data) / sizeof(char *);
 
 
 /** Retrieves processor identification from CP15 register 0.
- *
+ * 
  * @param cpu Structure for storing CPU identification.
- * See page B4-1630 of ARM Architecture Reference Manual.
  */
 static void arch_cpu_identify(cpu_arch_t *cpu)
 {
-	const uint32_t ident = MIDR_read();
-
-	cpu->imp_num = (ident >> MIDR_IMPLEMENTER_SHIFT) & MIDR_IMPLEMENTER_MASK;
-	cpu->variant_num = (ident >> MIDR_VARIANT_SHIFT) & MIDR_VARIANT_MASK;
-	cpu->arch_num = (ident >> MIDR_ARCHITECTURE_SHIFT) & MIDR_ARCHITECTURE_MASK;
-	cpu->prim_part_num = (ident >> MIDR_PART_NUMBER_SHIFT) & MIDR_PART_NUMBER_MASK;
-	cpu->rev_num = (ident >> MIDR_REVISION_SHIFT) & MIDR_REVISION_MASK;
-
-	// TODO CPUs with arch_num == 0xf use CPUID scheme for identification
-	cpu->dcache_levels = dcache_levels();
-
-	for (unsigned i = 0; i < cpu->dcache_levels; ++i) {
-		cpu->dcache[i].ways = dcache_ways(i);
-		cpu->dcache[i].sets = dcache_sets(i);
-		cpu->dcache[i].way_shift = 31 - log2(cpu->dcache[i].ways);
-		cpu->dcache[i].set_shift = dcache_linesize_log(i);
-		cpu->dcache[i].line_size = 1 << dcache_linesize_log(i);
-		printf("Found DCache L%u: %u-way, %u sets, %u byte lines "
-		    "(shifts: w%u, s%u)\n", i + 1, cpu->dcache[i].ways,
-		    cpu->dcache[i].sets, cpu->dcache[i].line_size,
-		    cpu->dcache[i].way_shift, cpu->dcache[i].set_shift);
-	}
+	uint32_t ident;
+	asm volatile (
+		"mrc p15, 0, %[ident], c0, c0, 0\n"
+		: [ident] "=r" (ident)
+	);
+	
+	cpu->imp_num = ident >> 24;
+	cpu->variant_num = (ident << 8) >> 28;
+	cpu->arch_num = (ident << 12) >> 28;
+	cpu->prim_part_num = (ident << 16) >> 20;
+	cpu->rev_num = (ident << 28) >> 28;
 }
 
-/** Enables unaligned access and caching for armv6+ */
+/** Does nothing on ARM. */
 void cpu_arch_init(void)
 {
-	uint32_t control_reg = SCTLR_read();
-	
-	/* Turn off tex remap, RAZ/WI prior to armv7 */
-	control_reg &= ~SCTLR_TEX_REMAP_EN_FLAG;
-	/* Turn off accessed flag, RAZ/WI prior to armv7 */
-	control_reg &= ~(SCTLR_ACCESS_FLAG_EN_FLAG | SCTLR_HW_ACCESS_FLAG_EN_FLAG);
-
-	/* Unaligned access is supported on armv6+ */
-#if defined(PROCESSOR_ARCH_armv7_a) | defined(PROCESSOR_ARCH_armv6)
-	/* Enable unaligned access, RAZ/WI prior to armv6
-	 * switchable on armv6, RAO/WI writes on armv7,
-	 * see ARM Architecture Reference Manual ARMv7-A and ARMv7-R edition
-	 * L.3.1 (p. 2456) */
-	control_reg |= SCTLR_UNALIGNED_EN_FLAG;
-	/* Disable alignment checks, this turns unaligned access to undefined,
-	 * unless U bit is set. */
-	control_reg &= ~SCTLR_ALIGN_CHECK_EN_FLAG;
-	/* Enable caching, On arm prior to armv7 there is only one level
-	 * of caches. Data cache is coherent.
-	 * "This means that the behavior of accesses from the same observer to
-	 * different VAs, that are translated to the same PA
-	 * with the same memory attributes, is fully coherent."
-	 *    ARM Architecture Reference Manual ARMv7-A and ARMv7-R Edition
-	 *    B3.11.1 (p. 1383)
-	 * We are safe to turn this on. For arm v6 see ch L.6.2 (p. 2469)
-	 * L2 Cache for armv7 is enabled by default (i.e. controlled by
-	 * this flag).
-	 */
-	control_reg |= SCTLR_CACHE_EN_FLAG;
-#endif
-#ifdef PROCESSOR_ARCH_armv7_a
-	 /* ICache coherency is elaborate on in barrier.h.
-	  * VIPT and PIPT caches need maintenance only on code modify,
-	  * so it should be safe for general use.
-	  * Enable branch predictors too as they follow the same rules
-	  * as ICache and they can be flushed together
-	  */
-	if ((CTR_read() & CTR_L1I_POLICY_MASK) != CTR_L1I_POLICY_AIVIVT) {
-		control_reg |=
-		    SCTLR_INST_CACHE_EN_FLAG | SCTLR_BRANCH_PREDICT_EN_FLAG;
-	}
-#endif
-	SCTLR_write(control_reg);
-
-#ifdef CONFIG_FPU
-	fpu_setup();
-#endif
-
-#ifdef PROCESSOR_ARCH_armv7_a
-	if ((ID_PFR1_read() & ID_PFR1_GEN_TIMER_EXT_MASK) !=
-	    ID_PFR1_GEN_TIMER_EXT) {
-		PMCR_write(PMCR_read() | PMCR_E_FLAG | PMCR_D_FLAG);
-		PMCNTENSET_write(PMCNTENSET_CYCLE_COUNTER_EN_FLAG);
-	}
-#endif
 }
 
 /** Retrieves processor identification and stores it to #CPU.arch */
-void cpu_identify(void)
+void cpu_identify(void) 
 {
 	arch_cpu_identify(&CPU->arch);
@@ -192,132 +108,22 @@
 void cpu_print_report(cpu_t *m)
 {
-	printf("cpu%d: vendor=%s, architecture=%s, part number=%x, "
+	const char *vendor = imp_data[0];
+	const char *architecture = arch_data[0];
+	cpu_arch_t * cpu_arch = &m->arch;
+
+	if ((cpu_arch->imp_num) > 0 &&
+	    (cpu_arch->imp_num < (imp_data_length + IMP_DATA_START_OFFSET))) {
+		vendor = imp_data[cpu_arch->imp_num - IMP_DATA_START_OFFSET];
+	}
+
+	if ((cpu_arch->arch_num) > 0 &&
+	    (cpu_arch->arch_num < arch_data_length)) {
+		architecture = arch_data[cpu_arch->arch_num];
+	}
+
+	printf("cpu%d: vendor=%s, architecture=ARM%s, part number=%x, "
 	    "variant=%x, revision=%x\n",
-	    m->id, implementer(m->arch.imp_num),
-	    architecture_string(&m->arch), m->arch.prim_part_num,
-	    m->arch.variant_num, m->arch.rev_num);
-}
-
-/** See chapter B4.1.19 of ARM Architecture Reference Manual */
-static unsigned dcache_linesize_log(unsigned level)
-{
-#ifdef PROCESSOR_ARCH_armv7_a
-	CSSELR_write((level & CCSELR_LEVEL_MASK) << CCSELR_LEVEL_SHIFT);
-	const unsigned ls_log = 2 +
-	    ((CCSIDR_read() >> CCSIDR_LINESIZE_SHIFT) & CCSIDR_LINESIZE_MASK);
-	return ls_log + 2; //return log2(bytes)
-#endif
-	return 0;
-
-}
-
-/** See chapter B4.1.19 of ARM Architecture Reference Manual */
-static unsigned dcache_ways(unsigned level)
-{
-#ifdef PROCESSOR_ARCH_armv7_a
-	CSSELR_write((level & CCSELR_LEVEL_MASK) << CCSELR_LEVEL_SHIFT);
-	const unsigned ways = 1 +
-	    ((CCSIDR_read() >> CCSIDR_ASSOC_SHIFT) & CCSIDR_ASSOC_MASK);
-	return ways;
-#endif
-	return 0;
-}
-
-/** See chapter B4.1.19 of ARM Architecture Reference Manual */
-static unsigned dcache_sets(unsigned level)
-{
-#ifdef PROCESSOR_ARCH_armv7_a
-	CSSELR_write((level & CCSELR_LEVEL_MASK) << CCSELR_LEVEL_SHIFT);
-	const unsigned sets = 1 +
-	    ((CCSIDR_read() >> CCSIDR_NUMSETS_SHIFT) & CCSIDR_NUMSETS_MASK);
-	return sets;
-#endif
-	return 0;
-}
-
-unsigned dcache_levels(void)
-{
-	unsigned levels = 0;
-#ifdef PROCESSOR_ARCH_armv7_a
-	const uint32_t val = CLIDR_read();
-	for (unsigned i = 1; i <= 7; ++i) {
-		const unsigned ctype = CLIDR_CACHE(i, val);
-		switch (ctype) {
-		case CLIDR_DCACHE_ONLY:
-		case CLIDR_SEP_CACHE:
-		case CLIDR_UNI_CACHE:
-			++levels;
-		default:
-			(void)0;
-		}
-	}
-#endif
-	return levels;
-}
-
-static void dcache_clean_manual(unsigned level, bool invalidate,
-    unsigned ways, unsigned sets, unsigned way_shift, unsigned set_shift)
-{
-
-	for (unsigned i = 0; i < ways; ++i) {
-		for (unsigned j = 0; j < sets; ++j) {
-			const uint32_t val =
-			    ((level & 0x7) << 1) |
-			    (j << set_shift) | (i << way_shift);
-			if (invalidate)
-				DCCISW_write(val);
-			else
-				DCCSW_write(val);
-		}
-	}
-}
-
-void dcache_flush(void)
-{
-	/* See ARM Architecture Reference Manual ch. B4.2.1 p. B4-1724 */
-	const unsigned levels = dcache_levels();
-	for (unsigned i = 0; i < levels; ++i) {
-		const unsigned ways = dcache_ways(i);
-		const unsigned sets = dcache_sets(i);
-		const unsigned way_shift =  31 - log2(ways);
-		const unsigned set_shift = dcache_linesize_log(i);
-		dcache_clean_manual(i, false, ways, sets, way_shift, set_shift);
-	}
-}
-
-void dcache_flush_invalidate(void)
-{
-	/* See ARM Architecture Reference Manual ch. B4.2.1 p. B4-1724 */
-	const unsigned levels = dcache_levels();
-	for (unsigned i = 0; i < levels; ++i) {
-		const unsigned ways = dcache_ways(i);
-		const unsigned sets = dcache_sets(i);
-		const unsigned way_shift =  31 - log2(ways);
-		const unsigned set_shift = dcache_linesize_log(i);
-		dcache_clean_manual(i, true, ways, sets, way_shift, set_shift);
-	}
-}
-
-
-void cpu_dcache_flush(void)
-{
-	for (unsigned i = 0; i < CPU->arch.dcache_levels; ++i)
-		dcache_clean_manual(i, false,
-		    CPU->arch.dcache[i].ways, CPU->arch.dcache[i].sets,
-		    CPU->arch.dcache[i].way_shift, CPU->arch.dcache[i].set_shift);
-}
-
-void cpu_dcache_flush_invalidate(void)
-{
-	const unsigned levels =  dcache_levels();
-	for (unsigned i = 0; i < levels; ++i)
-		dcache_clean_manual(i, true,
-		    CPU->arch.dcache[i].ways, CPU->arch.dcache[i].sets,
-		    CPU->arch.dcache[i].way_shift, CPU->arch.dcache[i].set_shift);
-}
-
-void icache_invalidate(void)
-{
-	ICIALLU_write(0);
+	    m->id, vendor, architecture, cpu_arch->prim_part_num,
+	    cpu_arch->variant_num, cpu_arch->rev_num);
 }
 
Index: kernel/arch/arm32/src/dummy.S
===================================================================
--- kernel/arch/arm32/src/dummy.S	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/arm32/src/dummy.S	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -32,4 +32,9 @@
 .global asm_delay_loop
 
+.global fpu_context_restore
+.global fpu_context_save
+.global fpu_enable
+.global fpu_init
+
 .global sys_tls_set
 .global dummy
@@ -41,4 +46,16 @@
 	mov	pc, lr
 
+fpu_context_restore:
+	mov	pc, lr
+    
+fpu_context_save:
+	mov	pc, lr
+    
+fpu_enable:
+	mov	pc, lr
+
+fpu_init:
+	mov	pc, lr
+    
 # not used on ARM
 sys_tls_set:
Index: kernel/arch/arm32/src/exception.c
===================================================================
--- kernel/arch/arm32/src/exception.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/arm32/src/exception.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -39,5 +39,4 @@
 #include <interrupt.h>
 #include <arch/mm/page_fault.h>
-#include <arch/cp15.h>
 #include <arch/barrier.h>
 #include <print.h>
@@ -74,5 +73,5 @@
 	/* make it LDR instruction and store at exception vector */
 	*vector = handler_address_ptr | LDR_OPCODE;
-	smc_coherence(vector);
+	smc_coherence(*vector);
 	
 	/* store handler's address */
@@ -118,29 +117,21 @@
 
 #ifdef HIGH_EXCEPTION_VECTORS
-/** Activates use of high exception vectors addresses.
- *
- * "High vectors were introduced into some implementations of ARMv4 and are
- * required in ARMv6 implementations. High vectors allow the exception vector
- * locations to be moved from their normal address range 0x00000000-0x0000001C
- * at the bottom of the 32-bit address space, to an alternative address range
- * 0xFFFF0000-0xFFFF001C near the top of the address space. These alternative
- * locations are known as the high vectors.
- *
- * Prior to ARMv6, it is IMPLEMENTATION DEFINED whether the high vectors are
- * supported. When they are, a hardware configuration input selects whether
- * the normal vectors or the high vectors are to be used from
- * reset." ARM Architecture Reference Manual A2.6.11 (p. 64 in the PDF).
- *
- * ARM920T (gta02) TRM A2.3.5 (PDF p. 36) and ARM926EJ-S (icp) 2.3.2 (PDF p. 42)
- * say that armv4 an armv5 chips that we support implement this.
- */
+/** Activates use of high exception vectors addresses. */
 static void high_vectors(void)
 {
-	uint32_t control_reg = SCTLR_read();
+	uint32_t control_reg;
+	
+	asm volatile (
+		"mrc p15, 0, %[control_reg], c1, c0"
+		: [control_reg] "=r" (control_reg)
+	);
 	
 	/* switch on the high vectors bit */
-	control_reg |= SCTLR_HIGH_VECTORS_EN_FLAG;
+	control_reg |= CP15_R1_HIGH_VECTORS_BIT;
 	
-	SCTLR_write(control_reg);
+	asm volatile (
+		"mcr p15, 0, %[control_reg], c1, c0"
+		:: [control_reg] "r" (control_reg)
+	);
 }
 #endif
@@ -155,25 +146,4 @@
 }
 
-/** Undefined instruction exception handler.
- *
- * Calls scheduler_fpu_lazy_request
- */
-static void undef_insn_exception(unsigned int exc_no, istate_t *istate)
-{
-#ifdef CONFIG_FPU
-	if (handle_if_fpu_exception()) {
-		/*
-		 * Retry the failing instruction,
-		 * ARM Architecture Reference Manual says on p.B1-1169
-		 * that offset for undef instruction exception is 4
-		 */
-		istate->pc -= 4;
-		return;
-	}
-#endif
-	fault_if_from_uspace(istate, "Undefined instruction.");
-	panic_badtrap(istate, exc_no, "Undefined instruction.");
-}
-
 /** Initializes exception handling.
  *
@@ -183,5 +153,4 @@
 void exception_init(void)
 {
-	// TODO check for availability of high vectors for <= armv5
 #ifdef HIGH_EXCEPTION_VECTORS
 	high_vectors();
@@ -189,6 +158,4 @@
 	install_exception_handlers();
 	
-	exc_register(EXC_UNDEF_INSTR, "undefined instruction", true,
-	    (iroutine_t) undef_insn_exception);
 	exc_register(EXC_IRQ, "interrupt", true,
 	    (iroutine_t) irq_exception);
Index: kernel/arch/arm32/src/mach/gta02/gta02.c
===================================================================
--- kernel/arch/arm32/src/mach/gta02/gta02.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/arm32/src/mach/gta02/gta02.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup arm32gta02
+/** @addtogroup arm32gxemul
  * @{
  */
